#include <stdbool.h>

/* Renvoie le nom du fichier contenu les données nécessaires
   pour dessiner le caractère c */
char* img_filename(char c);


/* Affiche la matrice G de n lignes et m colonnes par blocs de K colonnes.
Par exemple, si G est la matrice suivante:
AAABBBCCC
AAABBBCCC
alors print_bloc(G, 2, 9, 5) affichera:
AAABB
AAABB
BCCC
BCCC
*/
void print_bloc(char** G, int n, int m, int K);


/* Génère une grille de pixels 8x8 pour le caractère `forme`,
   utilisant c pour les pixels actifs */
char** grille_pixels(char forme, char c);


/* Renvoie un tableau de 0 et de 1 de longueur 8 donnant
la décomposition de n en base 2. n est supposé entre 0 et 255 */
bool* bits8(unsigned char n);


/* Recopie le contenu de la grille tampon dans la grille G,
   avec la case (i, j) de G contenant la case (0, 0) de tampon. 
   Par exemple si G contient
   ABCD
   EFGH
   IJKL
   et tampon contient
   ZZ
   YY
   alors après avoir appelé recopier(G, tampon, 1, 2), G contient:
   ABCD
   EFZZ
   IJYY
   */
void recopier(char** G, char** tampon, int n, int m, int i, int j);


/* Génère une grille 2D de taille 8 x 8n (où n est la longueur de phrase)
   représentant la phrase, où chaque caractère est représenté par une image
   de 8 par 8 pixels, chaque pixel étant le caractère pix  */
char** generer_grille(char* phrase, char pix);

/* Libère la mémoire allouée pour G une grille 2D de n lignes */
void free2D(char** G, int n);